/* 

  HEV General Utilities

  These source files are used by other programs in the NIST MSCD SAVG
  High-end Visulaization software suite- they are generally symlinked from
  the particular projects's directory to the $HEVROOT/src/genUtils
  directory.  When creating tarballs for release, symlinks are dereferenced
  so a complete package is contained in the tarball.

  Authors:
      John Kelso, Adele Peskin, Steve Satterfield
      Scientific Applications & Visualization Group
           SAVG web page: http://math.nist.gov/mcsd/savg/
      Mathematical & Computational Science Division
           MCSD web page: http://math.nist.gov/mcsd/
      National Institute of Standards and Technology
           NIST web page: http://www.nist.gov/


  For information about this software contact John Kelso, kelso@nist.gov

  "This software was developed at the National Institute of Standards and
  Technology by employees of the Federal Government in the course of their
  official duties. Pursuant to title 17 Section 105 of the United States
  Code this software is not subject to copyright protection and is in the
  public domain. This is an experimental system.  NIST assumes no
  responsibility whatsoever for its use by other parties, and makes no
  guarantees, expressed or implied, about its quality, reliability, or any
  other characteristic.

 We would appreciate acknowledgement if the software is used."

*/

// reads a line from stdin- replaces \n with \0
// allocates space and sets input to its address

// returns the number of characters read, not including the \0

// the first time you call it, set input to NULL

// input can be reused- if not NULL it's realloc'd to the initial size

// to avoid memory leaks and crashes, if you free(input) be sure to set it
// to NULL too

// the optional second parameter is a file pointer, defaults to stdin

#include <string.h>
#include <stdlib.h>
#define INIT_STRLEN (128)

int getString(char **input, FILE *fp=stdin) {
  int size = INIT_STRLEN ;

  if (!*input) 
    *input = (char *) malloc(INIT_STRLEN) ;
  else
    *input = (char *) realloc(*input, INIT_STRLEN) ;

  int i = 0 ;
  int c ;
  while(1) {
    c = getc(fp) ;
    if (c=='\n'|| c==EOF) {
      (*input)[i] = '\0' ;
      return c ;
    } else
      (*input)[i] = c ;
    i++ ;
    if (i==size) {
      size+=INIT_STRLEN ;
      *input = (char *) realloc(*input, size) ;
    }
  }
}

