/* 

  HEV General Utilities

  These source files are used by other programs in the NIST MSCD SAVG
  High-end Visulaization software suite- they are generally symlinked from
  the particular projects's directory to the $HEVROOT/src/genUtils
  directory.  When creating tarballs for release, symlinks are dereferenced
  so a complete package is contained in the tarball.

  Authors:
      John Kelso, Adele Peskin, Steve Satterfield
      Scientific Applications & Visualization Group
           SAVG web page: http://math.nist.gov/mcsd/savg/
      Mathematical & Computational Science Division
           MCSD web page: http://math.nist.gov/mcsd/
      National Institute of Standards and Technology
           NIST web page: http://www.nist.gov/


  For information about this software contact John Kelso, kelso@nist.gov

  "This software was developed at the National Institute of Standards and
  Technology by employees of the Federal Government in the course of their
  official duties. Pursuant to title 17 Section 105 of the United States
  Code this software is not subject to copyright protection and is in the
  public domain. This is an experimental system.  NIST assumes no
  responsibility whatsoever for its use by other parties, and makes no
  guarantees, expressed or implied, about its quality, reliability, or any
  other characteristic.

 We would appreciate acknowledgement if the software is used."

*/

/*
  removes everything after and including the comment character
  converts tabs to spaces
  if the resulting line is blank, return 0, else retun 1
*/

#include <string.h>

int normalize(char *line) {
  if (!line)
    return 1 ;

  int i ;

  // toss everything after a non-escaped '#'
  for (i=0; i<(int)strlen(line); i++) {
    if (line[i] == '#') {
      if (i==0 || line[i-1] != '\\')
	line[i] = '\0' ;
      break ;
    }
  }
  // convert tabs to spaces
  for (i=0; i<(int)strlen(line); i++) {
    if (line[i] == '\t')
      line[i] = ' ' ;
  }

  int allwhite = 1 ;
  // is the whole line empty?
  for (i=0; i<(int)strlen(line); i++) {
    if (line[i] == ' ') {
      allwhite = 1 ;
    } else {
      allwhite = 0 ;
      break ;
    }
  }

  if (allwhite)
    return 0 ;
  else
    return 1 ;

}
